<?php if (!defined('PmWiki')) exit();
/**
  EX - Single level section editing for PmWiki
  Written by (c) Petko Yotov 2021-2023 www.pmwiki.org/Petko

  This text is written for PmWiki; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version. See pmwiki.php for full details
  and lack of warranty.
*/
$RecipeInfo['EX']['Version'] = '20230429';

if ($action=='edit') $PostConfig['PostEX'] = 300;
else {
  # Move invisible (:textvar:...:) before {$var}
  DisableMarkup('textvar:');
  Markup('textvarX:', '<{$var}', '/\\(: *\\w[-\\w]* *:(?!\\)).*?:\\)/s', '');

  Markup('ex1', '>textvarX:', '/^.*$/s', 'FmtEX1');
  # Move edit link to end of heading, without floating it
  Markup('ex2', '>^!', "/(<h([1-6])>)($KeepToken\\d+X$KeepToken)(.*?)(<\\/h\\2>)/s", '$1$4 $3$5');
}

function FmtEX1($m) {
  global $HTMLStylesFmt, $MarkupMarkupLevel, $EnableAuthLinksEX;
  static $done = 0;
  if(@$MarkupMarkupLevel || $done) return $m[0];
  $done++;
  
  extract($GLOBALS["MarkupToHTML"]);
  if(IsEnabled($EnableAuthLinksEX) && !CondAuth($pagename, 'edit')) return $m[0];
  
  $prefix = '(?:^|\\(:(?:nl|groupheader):\\))';
  if(! preg_match_all("/$prefix(!{1,6})/m", $m[0], $mm)) return $m[0];
  
  $url = PageVar($pagename, '$PageUrl');
  $edit = XL("Edit");
  $linkfmt = "<a class='exlink' href='$url?action=edit&amp;ex=%1\$d' data-text=\"[$edit]\"></a>";
  SDVA($HTMLStylesFmt, array(
    'EX' => "a.exlink::before { content: attr(data-text); }
      a.exlink {font-size: .67rem; font-weight: normal; vertical-align: text-top; text-decoration: none;}"
  ));
  
  $toplevel = 7;
  foreach($mm[1] as $h) $toplevel = min($toplevel, strlen($h));
  
  return PRCB("/$prefix!{{$toplevel}}(?!!)/m", 'cb_inc_ex', $m[0], $linkfmt);
}
function cb_inc_ex($m, $linkfmt) {
  static $cnt = 0;
  return $m[0].Keep(sprintf($linkfmt, ++$cnt), 'X');
}


function PostEX($pagename) {
  global $HTMLStylesFmt, $HTMLFooterFmt, $InputTags;
  
  if (@$_POST['EXtext']) $_POST['text'] = $_POST['EXtext'];
  
  $i18n = array(
    'editsection' => XL('Edit section...'),
    'fullpage' => XL('*Full page'),
    'headsection' => XL('^Lead section (before the first heading)'),
  );
  $data = pm_json_encode($i18n, true);

  SDVA($HTMLFooterFmt, array(
    'EX' => '<script src="$FarmPubDirUrl/ex.js" data-i18n="'.$data.'"></script>'
  ));
  SDVA($HTMLStylesFmt, array(
    'EX' => "
      #selEX { width: 5em; text-overflow: ellipsis; }
      #selEX, #selEX ~ a img, #selEX ~ .GUIButtons a img { vertical-align: middle; }
      #selEX option { max-width: 15em; text-overflow: ellipsis; }"
  ));

  if (isset($_REQUEST['ex'])) {
    $v = intval($_REQUEST['ex']);
    $InputTags['e_form'][':html'] .=
      "<input type='hidden' id='prevEX' value=\"$v\" />";
  }
}

